// C Source File
// Created 01/07/2003; 12:00:05

#include "const.h"

// Ces fonctions ont pour but de grer une pile de pointeurs sur les espaces allous pendant l'execution
// Le but est de ne pas avoir  garder la trace de tous les blocs allous pour les librer  la fin du programme
// Ces pointeurs sont placs sur une pile elle mme alloue, et les blocs de mmoire correspondants sont librs
//  la fin tous en mme temps sur un simple appel de free_alloc_stack. Le bloc de mmoire utilis pour la pile
// est aussi libr, en dernier.
//
// Il faut appeller au dbut du programme : init_alloc_stack
// Ensuite utiliser les fonctions malloc_st et realloc_st pour allouer ou rallouer des blocs de mmoire
// Enfin pour tout librer en fin d'execution : free_alloc_stack
//
// En cas de manque de mmoire, la fonction exit_proc qui doit contenir free_alloc_stack est appelle



short allocPtrNb;
void **allocStack; // Pointeur sur la pile de pointeurs allous
extern void exit_proc(short);

// Initialise la pile de pointeurs ( appeller au dbut du programme)
void init_alloc_stack(void)
{
	allocPtrNb = 1;
	allocStack = (void **)malloc(sizeof(void *));
	allocStack[0] = allocStack;	// Premire valeur sur la pile de pointeurs, l'adresse de la pile elle mme
}

// Fonctionne comme malloc, sauf que le pointeur sur l'espace allou est plac sur la pile allocStack
void* malloc_st(unsigned long size)
{
	void* ptr;

	if (!(allocStack = (void **)realloc(allocStack, (allocPtrNb+1)*sizeof(void*)))) exit_proc(MEM_ERR); // Agrandir la taille de la pile
	if (!(ptr = malloc(size))) exit_proc(MEM_ERR); // Alloue l'espace, si problme quitte en dsallouant tout
	allocStack[allocPtrNb++] = ptr; // Sauver le nouveau pointeur et mettre  jour le nombre de pointeur allous
	return(ptr);
}

// Fonctionne comme realloc, sauf que le pointeur sur l'espace allou est (rem)plac sur la pile allocStack
void* realloc_st(void *ptr, unsigned long newSize)
{
	short i = 0;

	while (i<allocPtrNb && ptr != allocStack[i]) i++;
	if (i==allocPtrNb) return(malloc_st(newSize)); // Si le pointeur ne correspond pas  un espace dja allou, appeller malloc_st
	if (!(ptr = realloc(ptr, newSize))) exit_proc(MEM_ERR); // Realloue l'espace, si problme quitte en dsallouant tout
	allocStack[i] = ptr; // Remettre  jour le pointeur sur la pile
	return(ptr);
}


void free_sure(void* ptr) /* Libre un espace seulement si il  t allou */
{
	if (ptr != NULL) free(ptr);
}

short free_st(void* ptr)
{
	short i = 0;

	while (i<allocPtrNb && ptr != allocStack[i]) i++; // Recherche du pointeur dans la liste
	if (i==allocPtrNb) return(1); // Erreur, le pointeur n'est pas dans la liste
	free_sure(allocStack[i]); // Librer l'espace
	allocStack[i] = NULL; // Vider l'emplacement pour viter un deuxime free  l'appel en fin de programme de free_alloc_stack
	return(0);
}


// Vider la pile en librant tous les pointeurs placs dessus ( appeller  la fin du programme)
void free_alloc_stack(void)
{
	short i;

	for (i=allocPtrNb-1;i>0;i--) free_sure(allocStack[i]); // Librer successivement tous les pointeurs
	free_sure(allocStack);
}