
/******************************************************************************
*											Space Dementia II mod arena source											*
*																beta version 0.3															*
*															copyright	06/12/2003														*
*******************************************************************************
Ce projet est open-source, donc vous avez le droit d'utiliser des parties de ce
code, mais dans ce cas merci d'indiquer la provenance du code et un lien vers
mon site (www.moitib.fr.st). */


#include "main.h"


void exit_proc(short err)
{
	PortRestore(); // Redirige les fonctions graphiques vers le LCD

	if (err == GAME_LINK_ERR)
		{
		DrawStr(26, lcd_h-6, "Link error...", A_REPLACE);
		while (!_rowread(0x00)); // Tant qu'aucune touche n'est presse
		while (_rowread(0x00)); // Tant qu'une touche est presse
		}
	GrayOff();	// Arrete le grayscale

	free_alloc_stack();
	SetIntVec (AUTO_INT_1, saveInt1);
	OSFreeTimer(USER_TIMER);
	OSLinkClose();
  if (err == MEM_ERR) DlgMessage("Out of memory !", "Free some memory.", BT_NONE, BT_OK);	// si manque de mmoire
  if (err == LINK_ERR) DlgMessage("Link error", "Check the connection.", BT_NONE, BT_OK);	// si pb de link
  exit(0);	// Termine le programme
}


void _main(void)
{
	short calcState = UNKNOWN;
	short selMode = 0, up_flag = FALSE, down_flag = FALSE;

	// Pseudo-constantes (car dpend du modle de calc) stocke une fois pour toutes dans des variables
	lcd_w = LCD_WIDTH;
	lcd_h = LCD_HEIGHT;
	lcd_b = LCD_LINE_BYTES;
	lcd_focal = LCD_WIDTH>>1;
	lcd_wd = (lcd_w-160)>>1; // Supplment en pixels pour centrer horizontalement sur TI92+/V200
	lcd_bd = (lcd_b-20)>>1;  // Supplment en octets
	lcd_hd = (lcd_h-100)>>1;

	saveInt1 = GetIntVec(AUTO_INT_1);
	SetIntVec (AUTO_INT_1, DUMMY_HANDLER);   // Redirige l'auto-interruption 1 vers "rien"

	init_render_ptr(); // Initialise les variables associes aux espaces allous dans la fonction render_object
	init_alloc_stack(); // Initialiser la pile de pointeurs sur espaces allous
	randomize(); // Initialise le gnrateur de nombres "alatoires"


// Menu principal
	GrayOn(); // Dmarre le grayscale

	Vscreen0 = (void*)malloc_st(2*LCD_SIZE + 30*10); // Alloue de l'espace pour l'cran virtuel
	Vscreen1 = Vscreen0 + 30*5;	 // Marge de 5 lignes en dbut et fin de l'cran virtuel pour viter tout dbordement de mmoire lors de l'criture
	PortSet(Vscreen1, 239, 127); // Redirige les fonctions graphiques vers l'cran virtuel

	while (1)
		{
		do
			{
			FontSetSys(F_4x6); // Taille de caractres (petite)
			memset(Vscreen1, 0xff, 2*LCD_SIZE); /* Noircir l'cran (les deux zones) */
			GridGraySprite(lcd_bd, lcd_hd, 20, 100, titlepic_dark, titlepic_light, Vscreen1, Vscreen2);
			DrawStr(62+lcd_wd, 92+lcd_hd, "www.moitib.fr.st", A_REVERSE);
			DrawStr(144+lcd_wd, 92+lcd_hd, "v0.3", A_REVERSE);
			DrawVirtual();

			// Gestion du menu : singleplayer/host/join/exit
			// Les flags ont pour but d'viter les changements successif du menu si l'utilisateur laisse la touche UP ou DOWN appuye
			selMode = 0;

			while (_rowread(0x00)); // Tant qu'une touche est presse, attendre

			while(!(_keytest(RR_2ND) || _keytest(RR_ENTER)))
				{
				if (_keytest(RR_UP) && !up_flag)
					{
					selMode--;
					if (selMode == -1) selMode = 3;
					GridGraySprite(lcd_bd, lcd_hd+75, 20, 7, &(menu_sprt[selMode<<1][0]), &(menu_sprt[(selMode<<1)+1][0]), Vscreen1, Vscreen2);
					DrawVirtual();
					up_flag = TRUE;
					}
				if (!_keytest(RR_UP) && up_flag) up_flag = FALSE;

				if (_keytest(RR_DOWN) && !down_flag)
					{
					selMode++;
					if (selMode == 4) selMode = 0;
					GridGraySprite(lcd_bd, lcd_hd+75, 20, 7, &(menu_sprt[selMode<<1][0]), &(menu_sprt[(selMode<<1)+1][0]), Vscreen1, Vscreen2);
					DrawVirtual();
					down_flag = TRUE;
					}
				if (!_keytest(RR_DOWN) && down_flag) down_flag = FALSE;
				if (_keytest(RR_ESC)) { selMode = 3; break; }
				}

			switch (selMode)
				{
				case 0:
				calcState = SINGLE;
				memset(Vscreen1 , 0xff, 2*LCD_SIZE);/* Noircir l'cran (les deux zones) */
				GridGraySprite(lcd_bd, 4, 20, 7, &(menu_sprt[0][0]), &(menu_sprt[1][0]), Vscreen1, Vscreen2);
				options(); // Mode Single player
				break;

				case 1:	calcState = host(); // Host
				break;

				case 2: calcState = join(); // Join
				break;

				case 3:
				while(_keytest(RR_2ND)); // Attendre le relchement de 2nd
				exit_proc(NO_ERR); // Exit
				break;
				}

		} while (calcState == UNKNOWN);

		start_arena(calcState); // Dmmarer le mod arne en Singleplayer, ou Multiplayer Hte ou Client
		memset(Vscreen1, 0xff, 2*LCD_SIZE); // Efface l'cran virtuel
		}
}

